/*

[----------------------------------------]
##########################################
#  ### # ## ###     ##  ###  #    ########
# # ## # # #### ### ## # # # # ### #######
# ## # #  #####     ## ## ## #    ########
# ## # # # #### ### ## ## ## # ###########
# ##  ## ## ### ### ## ##### # ###########
##########################################
[---------Version 1.0 for Allegro--------]

NKAMP and it's code, my hard work, etc. is (C) 1999 Nick Kochakian

Web:    http://come.to/dn3
E-mail: nickk@worldnet.att.net
*/

#define NKAMP_VERSION "NKAMP Version 1.0 for Allegro"
#define NKAMP_CODER   "Nick Kochakian"

typedef struct ADLChannels { //Keeps track of the status of an Adlib channel
        int note, octave;
        int freq, vol;
} ADLChannels;

typedef struct RADEffect_List { //Keeps track of the effects that are
                                //present.
        unsigned char command, value;
        unsigned char speed;
} RADEffect_List;

ADLChannels    adl_channels[9]; //Of course we're only going to use 9 channels
RADEffect_List rad_effects[9];  //:)


//The module stuff:

typedef struct NKAMPInst { //An Adlib instrument
        unsigned char c0, m0, c1, m1, c2, m2, c3, m3;
        unsigned char cm;
        unsigned char c4, m4;
} NKAMPInst;

typedef struct NKAMPOrder { //This is the structure for the order list.
                            //It's going to expand as the support for
                            //different formats expands.
        unsigned char play_pattern;
} NKAMPOrder;

typedef struct NKAMPPattern { //The standard for all Adlib mods (except for
        struct {              //that crazy Edlib! :)
               struct {
                      unsigned char is_used;
                      unsigned char note[2];
                      unsigned char effect;
               } line[64]; //64 lines in one channel
        } channel[9]; //9 channels for the song!
} NKAMPPattern;

typedef struct NKAMP {
        unsigned char slow_timer;
        unsigned char initial_speed;
        unsigned char num_inst;   //The number of instruments used
        NKAMPInst *Inst;          //The instrument data

        unsigned char num_orders; //The length of the order list (up to 128)
        NKAMPOrder *Order;        //Yep, the pattern order data!

        NKAMPPattern *Pat;        //Pattern data

        unsigned char cur_pattern, cur_line, cur_order;
        unsigned char cur_speed;
        //cur = current, btw :)
} NKAMP;

NKAMP *NKAMP_Music; //This is a pointer to a module

//Flags:
typedef struct NKAMPFlags {
        unsigned char NKAMP_Loop;
        unsigned char NKAMP_Handler_installed;
        unsigned char music_is_playing;
        unsigned char speed_counter;
        unsigned char use_volume, use_effects;
} NKAMPFlags;

NKAMPFlags nkamp_flags;

//Prototypes:


//From headers.c:
int nkamp_detect_header(char *filename);

//From load_nka.c:
NKAMP *nkamp_load(char *filename);

//From nkamp.c:
void nkamp_get_values(NKAMP *r, unsigned char pattern, unsigned char cur_line, unsigned char ch,
                unsigned char *note_num, unsigned char *octave,
                unsigned char *inst, unsigned char *e_cmd, unsigned char *e_val);
void nkamp_reset_channels();
int nkamp_init();
int nkamp_play(NKAMP *music, int loop);
int nkamp_stop();
int nkamp_resume();
void nkamp_keyon(int voice, int freq, int octave);
void nkamp_apply_channels();
void nkamp_play_inst(NKAMP *r, int voice, unsigned char n, unsigned char freq, unsigned char octave);
void nkamp_music_handler();
int free_nkamp(NKAMP *music);

//From load_rad.c:
/*
    Welcome to the wonderful world of...

           
         
              
                         
           
           
           
 RAD Ascii GFX by: Rouge and Void of REALITY PRODUCTIONS
*/
NKAMP *load_rad(char *filename);
